#include "ContratException.h"
#include <sstream>

using namespace std;

ContratException::ContratException(const char* fichP, unsigned int prmLigne,
                                   const char* exprP, const char* msgP)
: logic_error(msgP), m_expression(exprP), m_fichier(fichP), m_ligne(prmLigne)
{
}

std::string ContratException::reqTexteException() const
{
   // ---  Prpare le message
   ostringstream os;
   os << "Message : " << what() << endl;
   os << "Fichier : " << m_fichier << endl;
   os << "Ligne   : " << m_ligne << endl;
   os << "Test    : " << m_expression << endl;

   return os.str();
}

AssertionException::AssertionException(const char* fichP, unsigned int prmLigne,
                                       const char* exprP)
: ContratException(fichP, prmLigne, exprP, "ERREUR D'ASSERTION")
{
}

PreconditionException::PreconditionException(const char* fichP, unsigned int prmLigne,
                                             const char* exprP)
: ContratException(fichP, prmLigne, exprP, "ERREUR DE PRECONDITION")
{
}

PostconditionException::PostconditionException(const char* fichP, unsigned int prmLigne,
                                               const char* exprP)
: ContratException(fichP, prmLigne, exprP, "ERREUR DE POSTCONDITION")
{
}

InvariantException::InvariantException(const char* fichP, unsigned int prmLigne,
                                       const char* exprP)
: ContratException(fichP, prmLigne, exprP, "ERREUR D'INVARIANT")
{
}




