/***************************************************************************
                          kcconfdlg.cpp  -  description
                             -------------------
    begin                : Sun Dec 17 2000
    copyright            : (C) 2000 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kcconfdlg.h"

KCConfDlg::KCConfDlg()
{
	int tmp;
	int i;
	
	newGame = false;
	config=KGlobal::config();
	CurrentPlayerOptionChanged();
	for (i = 3; i <= 15; i++)
	{
		cmbWidth->insertItem(QString().number(i));
		tmp = cmbWidth->currentItem();
		tmp = i - 3;
		WidthIndex.append (tmp);
		WidthValue.append (i);
		
		cmbHeight->insertItem(QString().number(i));
		tmp = cmbHeight->currentItem();
		tmp = i - 3;
		HeightIndex.append (tmp);
		HeightValue.append (i);
		//kdDebug () << "h " << tmp << ", h.v " << i << endl;
	}
	for (i = 20; i <= 33; i++)
	{
		cmbBarWidth->insertItem(QString().number(i));
		tmp = cmbBarWidth->currentItem();
		tmp = i;
		BarWidthIndex.append (tmp);
		BarWidthValue.append (i);
	}
	for (i = 0; i <= 25; i++)
	{
		cmbSpacing->insertItem(QString().number(i));
		tmp = cmbSpacing->currentItem();
		tmp = i;
		SpacingIndex.append (tmp);
		SpacingValue.append (i);
	}
	config->setGroup("Sizes");
	int a, b;
	a = config->readNumEntry ("KCNbCols", _defNbCols);
	b = findItem(a, WidthIndex, WidthValue);
	cmbWidth->setCurrentItem (b);
	cmbHeight->setCurrentItem (findItem(config->readNumEntry ("KCNbRows", _defNbRows), HeightIndex, HeightValue));
	cmbSpacing->setCurrentItem (findItem(config->readNumEntry ("KCSpacing", _defSpacing), SpacingIndex, SpacingValue));
	cmbBarHeight->setCurrentItem
		(findItem(config->readNumEntry ("KCBarH", _defNbRows), BarHeightIndex, BarHeightValue));
	cmbBarWidth->setCurrentItem
		(findItem(config->readNumEntry ("KCBarW", _setBarWidth), BarWidthIndex, BarWidthValue));
	cmbBorder->setCurrentItem
		(findItem(config->readNumEntry ("KCBorder", _defBorder), BorderIndex, BorderValue));

	config->setGroup("Game");
	nbPlayers = config->readNumEntry ("NbPlayers", 0);
	for (i = 1; i <= nbPlayers; i++)
	{
		cmbPlayer->insertItem(QString().number(i));
	}
}

KCConfDlg::~KCConfDlg()
{
}

void KCConfDlg::SaveOptions()
{
	//kdDebug() << "save" << endl;
	config->setGroup("Sizes");
	config->writeEntry("KCNbCols", cmbWidth->text(cmbWidth->currentItem()));
	config->writeEntry("KCNbRows", cmbHeight->text(cmbHeight->currentItem()));
	config->writeEntry("KCSpacing", cmbSpacing->text(cmbSpacing->currentItem()));
	config->writeEntry("KCBorder", cmbBorder->text(cmbBorder->currentItem()));
	config->writeEntry("KCBarW", cmbBarWidth->text(cmbBarWidth->currentItem()));
	config->writeEntry("KCBarH", cmbBarHeight->text(cmbBarHeight->currentItem()));
	config->setGroup("Colors");
	config->writeEntry("KCBGColor", kcolbutBGColor->color());
	emit configChanged();
}
void KCConfDlg::CancelOptions()
{
	//kdDebug() << "krweghnjwknfg" << endl;
}

void KCConfDlg::readConfig ()
{
//  config->setGroup("Colors");
// readColorEntry ( const QString &pKey, const QColor* pDefault = 0L )

//  bool bViewToolbar = config->readBoolEntry("Show Toolbar", true);
}

void KCConfDlg::butOKClicked()
{
	SaveOptions();
	emit configChanged();
	if (newGame)
	{
		emit restartGame();
	}
	delete this;
}

void KCConfDlg::butApplyClicked()
{
	SaveOptions();
}

void KCConfDlg::butCancelClicked()
{
	delete this;
}

void KCConfDlg::SpacingModeClicked()
{
/*
	switch (bgrpSpacingMode->id(bgrpSpacingMode->selected()))
	{
//		case 0: // custom spacing
//			break;
		case 1: // normal spacing
			cmbSpacing->setCurrentItem (10);
			break;
		case 2: // squeeze spacing
			cmbSpacing->setCurrentItem (0);
			break;
//		default:
	}
*/
}

void KCConfDlg::ShowPlayerOptions()
{
//	kdDebug () << "showplayeroptions" << endl;
}

void KCConfDlg::PlayerNew()
{
	cmbPlayer->insertItem(QString().number(++nbPlayers));
}

void KCConfDlg::PlayerOptions()
{
	KCPlConfDlg *a;
	a = new KCPlConfDlg;
	connect(a, SIGNAL(PLconfigChanged()), this, SLOT(slotEmitPlOptChanged()));
	a->show();
}

void KCConfDlg::slotEmitPlOptChanged()
{
	emit PLconfigChanged();
}

void KCConfDlg::PlayerDel()
{
	//read config and write it to a struct (without deleted player)
	//erase config
	//rewrite config
	//reload widget
}

void KCConfDlg::enableSave()
{
//	kdDebug () << "game need to be saved" << endl;
	butOK->setEnabled (true);
//	butApply->enabled = true;
}

void KCConfDlg::enableRestart()
{
//	kdDebug () << "game need to be restarted" << endl;
	butOK->setEnabled (true);
//	butApply->enabled = true;
	newGame = true;
}

void KCConfDlg::CurrentPlayerOptionChanged()
{
	QString	t;
		
	t = cmbPlayer->text(cmbPlayer->currentItem());
	config->setGroup("Game");
	if (t.length() == 0 || t == "0")
	{
		config->writeEntry ("Current Player Option", QString("1"));
	}
	else
	{
		config->writeEntry ("Current Player Option", t);
	}
}

#include "kcconfdlg.moc"
