/***************************************************************************
                          kcconfdlg.h  -  description
                             -------------------
    begin                : Sun Dec 17 2000
    copyright            : (C) 2000 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KCONFDLG_H
#define KCONFDLG_H

#include "kcconfigdlg.h"
#include "kcplconfdlg.h"
#include "kcdefault.h"
#include "utils.h"
#include "qcolorcell.h"

class KCConfDlg : public KCConfigDlg
{
	Q_OBJECT

	public:
		KCConfDlg();
		~KCConfDlg();
		void readConfig ();

	signals:
		void configChanged();
		void restartGame();
		void PLconfigChanged();

	protected slots:
		void slotEmitPlOptChanged();

	private:
		void SaveOptions();
		void CancelOptions();
		void butOKClicked();
		void butApplyClicked();	
		void butCancelClicked();
		void SpacingModeClicked();
		void ShowPlayerOptions();
		void PlayerNew();
		void PlayerOptions();
		void PlayerDel();
		void enableSave();
		void enableRestart();
		void CurrentPlayerOptionChanged();

		KConfig *config;
		QValueList<int> WidthIndex;
		QValueList<int> WidthValue;
		QValueList<int> HeightIndex;
		QValueList<int> HeightValue;
		QValueList<int> SpacingIndex;
		QValueList<int> SpacingValue;
		QValueList<int> BarWidthIndex;
		QValueList<int> BarWidthValue;
		QValueList<int> BarHeightIndex;
		QValueList<int> BarHeightValue;
		QValueList<int> BorderIndex;
		QValueList<int> BorderValue;
		bool newGame;
		int nbPlayers;
};

#endif //KCONFDLG_H
