/***************************************************************************
                          kcpiece.cpp  -  description
                             -------------------
    begin                : Wed Dec 27 2000
    copyright            : (C) 2000 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kcpiece.h"

KCPiece::KCPiece()
: m_x(0), m_y(0), m_h(0), m_w(0), m_p(0)
{
	m_pos = new KCPosition;
}

KCPiece::~KCPiece()
{
	delete m_pos;
}

QString KCPiece::getPlayerLetter() const
{
	if (m_p == NULL)
		return QString("@");
	return m_p->playerLetter();
}

QString KCPiece::getPlayerName() const
{
	if (m_p == NULL)
		return QString("@%#$@^*&");
	return m_p->playerName();
}

bool KCPiece::IsSame (const KCPiece &kcp, bool Complete) const
{
	bool retVal;

	retVal = false;
	if (Complete)
	{
		if ((this->m_x == kcp.m_x && this->m_y == kcp.m_y)
			&& (this->m_h == kcp.m_h && this->m_w == kcp.m_w)
			&& (this->m_pos->m_col == kcp.m_pos->m_col && this->m_pos->m_row == kcp.m_pos->m_row)
//			&& (this->isA(kcp.name())))
			&& (this->pieceType() == kcp.pieceType()))
		{
			retVal =  true;
		}
	}
	else
	{
		if (this->m_x == kcp.m_x && this->m_y == kcp.m_y)
		{
			retVal = true;
		}
	}
	return retVal;
}

KCPieceType KCPiece::pieceType (const KCPosition &pos)
{
	return pieceType (pos.m_col, pos.m_row);
}

KCPieceType KCPiece::pieceType (const KCPiece &pos)
{
	return pieceType (pos.m_pos->m_col, pos.m_pos->m_row);
}

KCPieceType KCPiece::pieceType (int X, int Y)
{
	if (X % 4 == 1)
	{
		if (Y % 4 == 1)
		{
			return KCCORNERPIECE;
		}
		else if (Y % 4 == 3)
		{
			return KCVERTICALPIECE;
		}
		else
		{
			return KCSPACEPIECE;
		}
	}
	else if (X % 4 == 3)
	{
		if (Y % 4 == 1)
		{
			return KCHORIZONTALPIECE;
		}
		else if (Y % 4 == 3)
		{
			return KCCENTERPIECE;
		}
		else
		{
			return KCSPACEPIECE;
		}
	}
	else
	{
		return KCSPACEPIECE;
	}
}

KCPieceType KCPiece::pieceType() const
{
	return pieceType(*this);
}
/*
KCSpacePiece::KCSpacePiece()
: m_x(0), m_y(0), m_h(0), m_w(0), m_col(0), m_row(0), m_p(0)
//: QObject(this, "KCSpacePiece")
{
}

KCCornerPiece::KCCornerPiece()
: m_x(0), m_y(0), m_h(0), m_w(0), m_col(0), m_row(0), m_p(0)
//: QObject(this, "KCCornerPiece")
{
}

KCCenterPiece::KCCenterPiece()
: m_x(0), m_y(0), m_h(0), m_w(0), m_col(0), m_row(0), m_p(0)
//: QObject(this, "KCCenterPiece")
{
}

KCHorizontalPiece::KCHorizontalPiece()
: m_x(0), m_y(0), m_h(0), m_w(0), m_col(0), m_row(0), m_p(0)
//: QObject(this, "KCHorizontalPiece")
{
}

KCVerticalPiece::KCVerticalPiece()
: m_x(0), m_y(0), m_h(0), m_w(0), m_col(0), m_row(0), m_p(0)
//: QObject(this, "KCVerticalPiece")
{
}
*/
#include "kcpiece.moc"
