/***************************************************************************
                          kcpiece.h  -  description
                             -------------------
    begin                : Wed Dec 27 2000
    copyright            : (C) 2000 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KCPIECE_H
#define KCPIECE_H

enum KCPieceType {KCSPACEPIECE, KCCORNERPIECE, KCCENTERPIECE, KCHORIZONTALPIECE, KCVERTICALPIECE};

#include "kcplayer.h"
#include "kcposition.h"

/**
  *@author Mathieu Jobin
  */

class KCPlayer;
class KCPosition;

class KCPiece : public QObject
{
	Q_OBJECT

	public:
		KCPiece();
//		KCPiece(const KCPosition &p);
		~KCPiece();
		QString getPlayerLetter() const;
		QString getPlayerName() const;
		KCPosition RandomizeSelectioningPiece() const;
		bool IsSame (const KCPiece &kcp, bool Complete = false) const;
		//static QString& name();
		static KCPieceType pieceType (const KCPosition &pos);
		static KCPieceType pieceType (const KCPiece &pos);
		static KCPieceType pieceType (int X, int Y);
		KCPieceType pieceType() const;

		int m_x, m_y, m_h, m_w;
		KCPosition *m_pos;
//		int type;
		KCPlayer *m_p;
};

class KCSpacePiece : public KCPiece
{
	public:
//		KCSpacePiece();
};

class KCCornerPiece : public KCPiece
{
	public:
//		KCCornerPiece();
};

class KCCenterPiece : public KCPiece
{
	public:
//		KCCenterPiece();
};

class KCHorizontalPiece : public KCPiece
{
	public:
//		KCHorizontalPiece();
};

class KCVerticalPiece : public KCPiece
{
	public:
//		KCVerticalPiece();
};

#endif

