/***************************************************************************
                          kcplayer.cpp  -  description
                             -------------------
    begin                : Wed Apr 10 2002
    copyright            : (C) 2002 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kcplayer.h"

bool KCPlayer::Played = false,
	KCPlayer::GameOver = false,
	KCPlayer::ComputerHavePlayed = false,
	KCPlayer::WasGameOver = false;
KCGame* KCPlayer::m_game = NULL;

KCPlayer::KCPlayer (const char *name)
{
	ASSERT(name != NULL && QString() != QString(name));
	m_name = new QString (name);
	m_color = new QColor (0, 0, 0);
	m_score = 0;
}

KCPlayer::KCPlayer (QString *name)
{
	ASSERT(name != NULL && QString() != QString(*name));
	m_name = new QString (*name);
	m_color = new QColor (0, 0, 0);
	m_score = 0;
}

KCPlayer::KCPlayer (const char *name, QColor *col)
{
	ASSERT(name != NULL && QString() != QString(name) && col != NULL);
	m_name = new QString (name);
	m_color = new QColor (*col);
	m_score = 0;
}

KCPlayer::KCPlayer (QString *name, QColor *col)
{
	ASSERT(name != NULL && QString() != QString(*name) && col != NULL);
	m_name = new QString (*name);
	m_color = new QColor (*col);
	m_score = 0;
}

KCPlayer::~KCPlayer ()
{
	delete m_name;
	delete m_color;
}

QString KCPlayer::playerName()
{
	if (m_name->isEmpty()) return QString("@%#$@^*&");
	return *m_name;
}

QString KCPlayer::playerLetter()
{
	if (m_name->isEmpty()) return QString("@");
//	kdDebug() << "x" << m_name->latin1() << "x" << endl;
	return QString(m_name->left(1)).upper();
}

void KCNetworkedPlayer::PlayTurn()
{
	emit havePlayed();
}

void KCHumanPlayer::PlayTurn()
{
//	emit havePlayed();
}

void KCComputerPlayer::PlayTurn()
{
	KCPosition RandyMove;

	if (false == KCPlayer::GameOver)
	{
		while (false == KCPlayer::ComputerHavePlayed)
		{
			RandyMove = m_game->RandomizeSelectioningPiece();
			if (true == m_game->MoveIsPossible(&RandyMove))
			{
				// ComputerHavePlayed and Played are set to true in MarkPlayed.
				m_game->MarkPlayed ((m_game->Pos2Piece (RandyMove)));
				if (false == m_game->CheckFill((m_game->Pos2Piece (RandyMove))))
				{
					KCPlayer::Played = true;
				}
				else
				{
					KCPlayer::ComputerHavePlayed = false;
					KCPlayer::Played = false;
					KCPlayer::WasGameOver = false;
				}
			}
		}
		KCPlayer::ComputerHavePlayed = false;
		emit havePlayed();
	}
	else
	{
		kdDebug() << "game over" << endl;
	}
}

#include "kcplayer.moc"

