/***************************************************************************
                          kcplayer.h  -  description
                             -------------------
    begin                : Wed Apr 10 2002
    copyright            : (C) 2002 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KCPLAYER_H
#define KCPLAYER_H

#include "kcdefault.h"
#include "kcpiece.h"
#include "kcgame.h"

enum KCPlayerType {KCHUMAN, KCCOMPUTER, KCNETWORKED};

class KCGame;

/*
class QColor;
class QString;
*/

class KCPlayer : public QObject
{
	Q_OBJECT

	friend class KCGame;
	friend class KCPlayerList;
	public:
		KCPlayer (const char *name);
		KCPlayer (QString *name);
		KCPlayer (const char *name, QColor *col);
		KCPlayer (QString *name, QColor *col);
		~KCPlayer ();
		QString playerName();
		QString playerLetter();
		virtual void PlayTurn() = 0;

	private:
		QString *m_name;
		QColor *m_color;
		int m_score;
	signals:
		void havePlayed();
	private:
		KCPlayer() {};
		static KCGame *m_game;
	protected:
		static bool Played, GameOver, ComputerHavePlayed, WasGameOver;
};

class KCComputerPlayer : public KCPlayer
{
	Q_OBJECT

	public:
		KCComputerPlayer () : /*QObject(this, KCComputerPlayer),*/ KCPlayer("CompIA1") {}
		KCComputerPlayer (const char *name) : KCPlayer(name) {}
		KCComputerPlayer (QString *name) : KCPlayer(name) {}
		KCComputerPlayer (const char *name, QColor *col) : KCPlayer(name, col) {}
		KCComputerPlayer (QString *name, QColor *col) : KCPlayer(name, col) {}
		virtual void PlayTurn();
};

class KCHumanPlayer : public KCPlayer
{
	Q_OBJECT

	public:
		KCHumanPlayer () : KCPlayer("Human1") {}
		KCHumanPlayer (const char *name) : KCPlayer(name) {}
		KCHumanPlayer (QString *name) : KCPlayer(name) {}
		KCHumanPlayer (const char *name, QColor *col) : KCPlayer(name, col) {}
		KCHumanPlayer (QString *name, QColor *col) : KCPlayer(name, col) {}
		virtual void PlayTurn();

};

class KCNetworkedPlayer : public KCPlayer
{
	Q_OBJECT

	public:
		KCNetworkedPlayer (): KCPlayer("Friend1"){}
		KCNetworkedPlayer (const char *name): KCPlayer(name){}
		KCNetworkedPlayer (QString *name): KCPlayer(name){}
		KCNetworkedPlayer (const char *name, QColor *col): KCPlayer(name, col){}
		KCNetworkedPlayer (QString *name, QColor *col): KCPlayer(name, col){}
		virtual void PlayTurn();
};

#endif // KCPLAYER_H

