/***************************************************************************
                          kcplayerlist.h  -  description
                             -------------------
    begin                : Thu Apr 11 2002
    copyright            : (C) 2002 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KCPLAYERLIST_H
#define KCPLAYERLIST_H

#include "kcdefault.h"
#include "kcplayer.h"
#include "klosecircuit.h"

class KCPlayer;
/*
class KCHumanPlayer;
class KCNetworkedPlayer;
class KCComputerPlayer;
*/

class KCPlayerList : public QObject
{
	Q_OBJECT

	public:
		KCPlayerList (KCGame *opGame);
		virtual ~KCPlayerList ();
		void clear();
		void GenerePlayers();
		void ResetScore();
		void SavePlayer(KCPlayer *p);
//		void SavePlayer(QString *name, QColor *col);
//		void AddPlayer(QString *name, QColor *col, KCPlayer (*fn)());
		void AddPlayer(KCPlayer *p);
//		void AddAndSavePlayer(KCPlayer *p);
		void DelPlayer(KCPlayer *p);
		void DelPlayer(int i);
		void DelPlayer(const QString &name);
		int nbPlayer();
		QString CurPlayerType() const;
	public slots:
		void Change_Player();
//		int curPlayer();
//		int curWinner();
//		int nextPlayer();
	public:
		QPtrList<KCPlayer> *Players;
		KCPlayer *CurPlayer;
		KCPlayer *Winner;
		KConfig *config;
	signals:
		void statusBarChanged(QString s);
	private:
		KCGame *the_game;
};

#endif // KCPLAYERLIST_H
