/***************************************************************************
                          kcposition.cpp  -  description
                             -------------------
    begin                : Fri May 3 2002
    copyright            : (C) 2002 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kcposition.h"

KCGame* KCPosition::thegame = NULL;

KCPosition::KCPosition()
: m_col(0), m_row(0)
{}

KCPosition::KCPosition(const KCPiece &obj)
: m_col(0), m_row(0)
{
	m_col = obj.m_pos->m_col;
	m_row = obj.m_pos->m_row;
}

KCPosition::KCPosition (int col, int row)
: m_col(col), m_row(row)
{}

long KCPosition::C() const
{
	return ((m_col) + ((m_row) * (KCPosition::thegame->nbCols() * 4) - 2));
}

long KCPosition::N(int dist) const
{
	dist *=2;
	return (m_col + (m_row - dist) * (KCPosition::thegame->nbCols() * 4) - 2);
}

long KCPosition::NE(int dist) const
{
	dist *=2;
	return ((m_col + dist) + ((m_row - dist) * (KCPosition::thegame->nbCols() * 4) - 2));
}

long KCPosition::E(int dist) const
{
	dist *=2;
	return ((m_col + dist) + ((m_row) * (KCPosition::thegame->nbCols() * 4) - 2));
}

long KCPosition::SE(int dist) const
{
	dist *=2;
	return ((m_col + dist) + ((m_row + dist) * (KCPosition::thegame->nbCols() * 4) - 2));
}

long KCPosition::S(int dist) const
{
	dist *=2;
	return ((m_col) + ((m_row + dist) * (KCPosition::thegame->nbCols() * 4) - 2));
}

long KCPosition::SW(int dist) const
{
	dist *=2;
	return ((m_col - dist) + ((m_row + dist) * (KCPosition::thegame->nbCols() * 4) - 2));
}

long KCPosition::W(int dist) const
{
	dist *=2;
	return ((m_col - dist) + ((m_row) * (KCPosition::thegame->nbCols() * 4) - 2));
}

long KCPosition::NW(int dist) const
{
	dist *=2;
	return ((m_col - dist) + ((m_row - dist) * (KCPosition::thegame->nbCols() * 4) - 2));
}

const KCPosition& KCPosition::operator= (const KCPosition &p)
{
	this->m_col = p.m_col;
	this->m_row = (&p)->m_row;
	return *this;
}
