/***************************************************************************
                          kcposition.h  -  description
                             -------------------
    begin                : Fri May 3 2002
    copyright            : (C) 2002 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KCPOSITION_H
#define KCPOSITION_H

#include "kcgame.h"
#include "kcplayer.h"
#include "kcpiece.h"

/**
  *@author Mathieu Jobin
  */

class KCPlayer;
class KCGame;
class KCPiece;

class KCPosition
{
	friend class KCGame;
	public:
		KCPosition();
		KCPosition(const KCPiece &obj);
		KCPosition (int col, int row);
		long C() const;
		long N(int dist = 1) const;
		long NE(int dist = 1) const;
		long E(int dist = 1) const;
		long SE(int dist = 1) const;
		long S(int dist = 1) const;
		long SW(int dist = 1) const;
		long W(int dist = 1) const;
		long NW(int dist = 1) const;
		const KCPosition& operator= (const KCPosition &p);
//		KCPosition (int x, int *Pos);
//		KCPiece* Pos2Piece ();
//		KCPiece* Pos2Piece (KCPosition p);
//		KCPiece* Pos2Piece (int col, int row);
//		static int Id2Pos (int x);
	public:
		/*
_property__cmt identifier property_parameter_list colon_cmt type property_accessors semicolon_cmt
{
	$$ := 'Q_PROPERTY( ' + $5 + ' ' + $2 + $3 + ' ' + $6 + ')' + $7;
}
		*/
		int m_col;
		int m_row;
	private:
		static KCGame* thegame;
};

#endif // KCPOSITION_H

