/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Thu Dec 20 2000
    copyright            : (C) 2000 by Mathieu Jobin
    email                : somekool@mytradecenter.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>
#include "kcdefault.h"
#include "klosecircuit.h"
#include "kcplayer.h"

//QMap<int, QString> plType;

void do_player (KCPlayer *a)
{
	kdDebug() << a->className() << endl;
	delete a;
}

int main_test ()
{
	do_player(new KCHumanPlayer());
	do_player(new KCComputerPlayer());
	do_player(new KCNetworkedPlayer());
	return 0;
}

static const char *description =
	I18N_NOOP("KloseCircuit");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE

static KCmdLineOptions options[] =
{
  { "+[File]", I18N_NOOP("file to open"), 0 },
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{
	KAboutData aboutData( "klosecircuit", I18N_NOOP("KloseCircuit"),
		VERSION, description, KAboutData::License_GPL,
		"(c) 2000, Mathieu Jobin");
	aboutData.addAuthor("Mathieu Jobin",0, "somekool@mytradecenter.com");
	KCmdLineArgs::init( argc, argv, &aboutData );
	KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

	KApplication app;
	
//	plType.insert(_tHuman, i18n("Human"));
//	plType.insert(_tComputer, i18n("Computer AI"));
//	plType.insert(_tNetwork, i18n("Networked"));

	if (app.isRestored())
	{
		RESTORE(KloseCircuitApp);
	}
	else
	{
		KloseCircuitApp *klosecircuit = new KloseCircuitApp();
		klosecircuit->show();
		KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
		args->clear();
	}
	return app.exec();
}
